
/*
 * Copyright (C) 2011 Technische Universitaet Muenchen
 * This file is part of the Sierpinski project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpinski
 *
 * This file was automatically generated by the sierpinski code generator
 */


inline void K_e_bbb_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bbn_forward();
		K_o_bob_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bbn_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bnb_forward();
		K_e_nbo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bnb_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bbn_forward();
		K_o_nob_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_nob_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_onn_forward();
		K_e_bno_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_onn_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_non_forward();
		K_o_noo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_non_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_onn_forward();
		K_e_nno_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_nno_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_onn_forward();
		K_o_non_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_onn_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_nno_forward();
		K_e_noo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_noo_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_onn_forward();
		K_o_oon_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if ((edge_left_trigger != 2) || (edge_right_trigger != 2))
			{
				new_state = 0;
				if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 3;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_oon_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_ono_forward();
		K_e_noo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 6;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_ono_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_oon_forward();
		K_o_noo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 5;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_noo_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_onn_forward();
		K_e_ono_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if ((edge_left_trigger != 2) || (edge_right_trigger != 2))
			{
				new_state = 0;
				if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 3;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bno_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_obn_forward();
		K_o_nob_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_obn_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bno_forward();
		K_e_noo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_nbo_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_onn_forward();
		K_o_bon_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bon_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_onb_forward();
		K_e_nbo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_onb_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bon_forward();
		K_o_noo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bob_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_onb_forward();
		K_e_bbo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bbo_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_obn_forward();
		K_o_bob_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bbb_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bnb_backward();
		K_o_bbo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bnb_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bbn_backward();
		K_e_nob_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bbn_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bnb_backward();
		K_o_nbo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_nbo_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_onn_backward();
		K_e_bon_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_onn_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_nno_backward();
		K_o_noo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_nno_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_onn_backward();
		K_e_non_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_non_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_onn_backward();
		K_o_nno_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_onn_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_non_backward();
		K_e_noo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_noo_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_onn_backward();
		K_o_ono_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if ((edge_left_trigger != 2) || (edge_right_trigger != 2))
			{
				new_state = 0;
				if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 3;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_ono_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_oon_backward();
		K_e_noo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 5;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_oon_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_ono_backward();
		K_o_noo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 6;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_noo_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_onn_backward();
		K_e_oon_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if ((edge_left_trigger != 2) || (edge_right_trigger != 2))
			{
				new_state = 0;
				if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 3;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bon_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_onb_backward();
		K_o_nbo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_onb_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bon_backward();
		K_e_noo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_nob_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_onn_backward();
		K_o_bno_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bno_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_obn_backward();
		K_e_nob_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_obn_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bno_backward();
		K_o_noo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bbo_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_obn_backward();
		K_e_bob_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bob_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_onb_backward();
		K_o_bbo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bbb_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bnb_forward();
		K_e_bbo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bbb_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bbn_backward();
		K_e_bob_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_nnn_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_nnn_forward();
		K_o_non_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_nnn_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_nnn_forward();
		K_e_nno_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_nnn_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_nnn_backward();
		K_o_nno_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_nnn_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_nnn_backward();
		K_e_non_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_ooo_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_oon_forward();
		K_o_ooo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if ((edge_left_trigger != 2) || (edge_right_trigger != 2))
			{
				new_state = 0;
				if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 7;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_ooo_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_ono_forward();
		K_e_ooo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if ((edge_left_trigger != 2) || (edge_right_trigger != 2))
			{
				new_state = 0;
				if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 7;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_ooo_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_ono_backward();
		K_o_ooo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if ((edge_left_trigger != 2) || (edge_right_trigger != 2))
			{
				new_state = 0;
				if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 7;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_ooo_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_oon_backward();
		K_e_ooo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if ((edge_left_trigger != 2) || (edge_right_trigger != 2))
			{
				new_state = 0;
				if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 7;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bnn_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_nbn_forward();
		K_o_nob_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_nbn_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bnn_forward();
		K_e_nno_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bnn_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_nnb_backward();
		K_o_nbo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_nnb_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bnn_backward();
		K_e_non_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bnn_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_nnb_forward();
		K_e_nbo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_nnb_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bnn_forward();
		K_o_non_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bnn_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_nbn_backward();
		K_e_nob_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_nbn_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bnn_backward();
		K_o_nno_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_boo_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_obn_forward();
		K_o_oob_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if ((edge_left_trigger != 2) || (edge_right_trigger != 2))
			{
				new_state = 0;
				if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 3;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_oob_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_ono_forward();
		K_e_boo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 6;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_boo_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_onb_backward();
		K_o_obo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if ((edge_left_trigger != 2) || (edge_right_trigger != 2))
			{
				new_state = 0;
				if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 3;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_obo_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_oon_backward();
		K_e_boo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 5;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_boo_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_onb_forward();
		K_e_obo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if ((edge_left_trigger != 2) || (edge_right_trigger != 2))
			{
				new_state = 0;
				if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 3;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_obo_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_oon_forward();
		K_o_boo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 5;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_boo_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_obn_backward();
		K_e_oob_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if ((edge_left_trigger != 2) || (edge_right_trigger != 2))
			{
				new_state = 0;
				if ((edge_left_trigger == 2) || (edge_right_trigger == 2))
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 3;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_oob_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_ono_backward();
		K_o_boo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_right_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 6;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_nbn_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_nnn_forward();
		K_o_bon_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_nbn_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_nnn_backward();
		K_e_bon_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_obo_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bno_backward();
		K_o_ooo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 5;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_obo_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bno_forward();
		K_e_ooo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_left_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 5;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_nnb_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_nnn_backward();
		K_o_bno_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_nnb_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_nnn_forward();
		K_e_bno_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_oob_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bon_forward();
		K_o_ooo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 6;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_oob_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bon_backward();
		K_e_ooo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if ((edge_right_trigger == 2) || (hyp_trigger == 2))
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 6;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bbn_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_nbn_forward();
		K_o_bob_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bbn_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_nbn_backward();
		K_e_bob_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_left_edge_stack->push(2);
	}
	else
	{
		comm_left_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bbo_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bnb_backward();
		K_o_obo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bbo_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bnb_forward();
		K_e_obo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_left_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_left_trigger&1) << 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_left_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_left_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 1;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_nbb_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bnn_forward();
		K_o_bon_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_nbb_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bnn_backward();
		K_o_bno_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_nbb_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bnn_forward();
		K_e_bno_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_left_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_nbb_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bnn_backward();
		K_e_bon_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	comm_right_edge_stack->push((outgoingEdgeStateInformation >> 2) & 1);
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_obb_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bon_forward();
		K_o_boo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_obb_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bno_backward();
		K_o_boo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_obb_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bno_forward();
		K_e_boo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_obb_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bon_backward();
		K_e_boo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char hyp_trigger = comm_right_edge_stack->pop();
	incomingEdgeStateTransfer |= (hyp_trigger&1) << 2;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
		}
		if (hyp_trigger == 2)
			repeat_traversal = true;
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 4;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bnb_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_nnb_backward();
		K_o_bbo_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bnb_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_nnb_forward();
		K_e_bbo_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	// spread coarsening information
	if (new_state == 2)
	{
		comm_right_edge_stack->push(2);
	}
	else
	{
		comm_right_edge_stack->push(0);
	}
	outgoingEdgeStateInformation &= 0;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_e_bob_forward()
{

	if (structure_lifo_in.getNextData())
	{
		K_o_bbn_forward();
		K_o_oob_forward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

inline void K_o_bob_backward()
{

	if (structure_lifo_in.getNextData())
	{
		K_e_bbn_backward();
		K_e_oob_backward();
		return;
	}
	unsigned char incomingEdgeStateTransfer = 0;
	unsigned char edge_right_trigger = comm_left_edge_stack->pop();
	incomingEdgeStateTransfer |= (edge_right_trigger&1) << 1;
	unsigned char old_state = adaptivity_state_flag_stack_in->pop();
	unsigned char oldEdgeStateTransfer = old_state >> 4;
	old_state &= 7;

	unsigned char new_state = automatonTable[old_state][incomingEdgeStateTransfer];
	unsigned char outgoingEdgeStateInformation = new_state >> 4;
	new_state = new_state & 7;

	if (new_state != 2)
	{
		if (edge_right_trigger == 2)
			repeat_traversal = true;
	}
	else
	{
		if (outgoingEdgeStateInformation != 0 || oldEdgeStateTransfer != 0)
		{
			oldEdgeStateTransfer = 0;
			repeat_traversal = true;
		}
		else
		{
			if (edge_right_trigger != 2)
			{
				new_state = 0;
					repeat_traversal = true;
			}
		}
	}

	outgoingEdgeStateInformation |= oldEdgeStateTransfer;
	// spread refine/coarsening information
	outgoingEdgeStateInformation &= 2;

	if (outgoingEdgeStateInformation != 0)
		repeat_traversal = true;

	new_state |= (outgoingEdgeStateInformation << 4);
	adaptivity_state_flag_stack_out->push(new_state);
}

static const int number_of_recursion_functions = 88;
typedef void (TThisClass::*TRecursiveMethod)();
enum ESFCMethod{
	SFC_METHOD_DEFAULT = 0,
	SFC_METHOD_FORCE_FORWARD = (1 << 0),
	SFC_METHOD_FORCE_BACKWARD = (1 << 1),
	SFC_METHOD_NEW_TO_OLD_EDGE_TYPES = (1 << 2),
	SFC_METHOD_OLD_TO_NEW_EDGE_TYPES = (1 << 3),
	SFC_METHOD_LIMITER___ = (1 << 4)
};

template <int specialMode = 0>
TRecursiveMethod getSFCMethod(CTriangle_Factory &i_cTriangleFactory)
{
	static TRecursiveMethod methodArray [2] [27] [2] =
	{
	{
	{
		&TThisClass::K_e_nnn_forward ,
		&TThisClass::K_e_nnn_backward 
	} ,
	{
		&TThisClass::K_e_nno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_nnb_forward ,
		&TThisClass::K_e_nnb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_non_backward 
	} ,
	{
		&TThisClass::K_e_noo_forward ,
		&TThisClass::K_e_noo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_nob_backward 
	} ,
	{
		&TThisClass::K_e_nbn_forward ,
		&TThisClass::K_e_nbn_backward 
	} ,
	{
		&TThisClass::K_e_nbo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_nbb_forward ,
		&TThisClass::K_e_nbb_backward 
	} ,
	{
		&TThisClass::K_e_onn_forward ,
		&TThisClass::K_e_onn_backward 
	} ,
	{
		&TThisClass::K_e_ono_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_onb_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_oon_backward 
	} ,
	{
		&TThisClass::K_e_ooo_forward ,
		&TThisClass::K_e_ooo_backward 
	} ,
	{
		&TThisClass::K_e_oob_forward ,
		&TThisClass::K_e_oob_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_obn_backward 
	} ,
	{
		&TThisClass::K_e_obo_forward ,
		&TThisClass::K_e_obo_backward 
	} ,
	{
		&TThisClass::K_e_obb_forward ,
		&TThisClass::K_e_obb_backward 
	} ,
	{
		&TThisClass::K_e_bnn_forward ,
		&TThisClass::K_e_bnn_backward 
	} ,
	{
		&TThisClass::K_e_bno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_bnb_forward ,
		&TThisClass::K_e_bnb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_bon_backward 
	} ,
	{
		&TThisClass::K_e_boo_forward ,
		&TThisClass::K_e_boo_backward 
	} ,
	{
		&TThisClass::K_e_bob_forward ,
		&TThisClass::K_e_bob_backward 
	} ,
	{
		&TThisClass::K_e_bbn_forward ,
		&TThisClass::K_e_bbn_backward 
	} ,
	{
		&TThisClass::K_e_bbo_forward ,
		&TThisClass::K_e_bbo_backward 
	} ,
	{
		&TThisClass::K_e_bbb_forward ,
		&TThisClass::K_e_bbb_backward 
	} 
	} ,
	{
	{
		&TThisClass::K_o_nnn_forward ,
		&TThisClass::K_o_nnn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_nno_backward 
	} ,
	{
		&TThisClass::K_o_nnb_forward ,
		&TThisClass::K_o_nnb_backward 
	} ,
	{
		&TThisClass::K_o_non_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_noo_forward ,
		&TThisClass::K_o_noo_backward 
	} ,
	{
		&TThisClass::K_o_nob_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_nbn_forward ,
		&TThisClass::K_o_nbn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_nbo_backward 
	} ,
	{
		&TThisClass::K_o_nbb_forward ,
		&TThisClass::K_o_nbb_backward 
	} ,
	{
		&TThisClass::K_o_onn_forward ,
		&TThisClass::K_o_onn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_ono_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_onb_backward 
	} ,
	{
		&TThisClass::K_o_oon_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_ooo_forward ,
		&TThisClass::K_o_ooo_backward 
	} ,
	{
		&TThisClass::K_o_oob_forward ,
		&TThisClass::K_o_oob_backward 
	} ,
	{
		&TThisClass::K_o_obn_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_obo_forward ,
		&TThisClass::K_o_obo_backward 
	} ,
	{
		&TThisClass::K_o_obb_forward ,
		&TThisClass::K_o_obb_backward 
	} ,
	{
		&TThisClass::K_o_bnn_forward ,
		&TThisClass::K_o_bnn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_bno_backward 
	} ,
	{
		&TThisClass::K_o_bnb_forward ,
		&TThisClass::K_o_bnb_backward 
	} ,
	{
		&TThisClass::K_o_bon_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_boo_forward ,
		&TThisClass::K_o_boo_backward 
	} ,
	{
		&TThisClass::K_o_bob_forward ,
		&TThisClass::K_o_bob_backward 
	} ,
	{
		&TThisClass::K_o_bbn_forward ,
		&TThisClass::K_o_bbn_backward 
	} ,
	{
		&TThisClass::K_o_bbo_forward ,
		&TThisClass::K_o_bbo_backward 
	} ,
	{
		&TThisClass::K_o_bbb_forward ,
		&TThisClass::K_o_bbb_backward 
	} 
	} 
	} 	;

	assert(i_cTriangleFactory.triangleType != CTriangle_Enums::TRIANGLE_TYPE_INVALID);
	assert(i_cTriangleFactory.evenOdd != CTriangle_Enums::EVEN_ODD_INVALID);

		assert(i_cTriangleFactory.edgeTypes.hyp != CTriangle_Enums::EDGE_TYPE_INVALID);
		assert(i_cTriangleFactory.edgeTypes.left != CTriangle_Enums::EDGE_TYPE_INVALID);
		assert(i_cTriangleFactory.edgeTypes.right != CTriangle_Enums::EDGE_TYPE_INVALID);
		CTriangle_Enums::EEdgeType hyp, left, right;
		if (specialMode == 0)
		{
			hyp = i_cTriangleFactory.edgeTypes.hyp;
			right = i_cTriangleFactory.edgeTypes.right;
			left = i_cTriangleFactory.edgeTypes.left;
		}
		else if (specialMode & SFC_METHOD_NEW_TO_OLD_EDGE_TYPES)
		{
			hyp = (i_cTriangleFactory.edgeTypes.hyp == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.hyp);
			right = (i_cTriangleFactory.edgeTypes.right == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.right);
			left = (i_cTriangleFactory.edgeTypes.left == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.left);
		}
		else if (specialMode & SFC_METHOD_OLD_TO_NEW_EDGE_TYPES)
		{
			hyp = (i_cTriangleFactory.edgeTypes.hyp == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.hyp);
			right = (i_cTriangleFactory.edgeTypes.right == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.right);
			left = (i_cTriangleFactory.edgeTypes.left == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.left);
		}
	#if DEBUG
		else
		{
			assert(false);
		}
	#endif
	CTriangle_Enums::EDirection direction;
	if (specialMode & SFC_METHOD_FORCE_FORWARD)
	{
		direction = CTriangle_Enums::DIRECTION_FORWARD;
	}
	else if (specialMode & SFC_METHOD_FORCE_BACKWARD)
	{
		direction = CTriangle_Enums::DIRECTION_BACKWARD;
	}
	else
	{
		direction = i_cTriangleFactory.traversalDirection;
	}

		assert(i_cTriangleFactory.traversalDirection != CTriangle_Enums::DIRECTION_INVALID);
	assert(i_cTriangleFactory.hypNormal != CTriangle_Enums::NORMAL_INVALID);
#if DEBUG
	assert(methodArray[i_cTriangleFactory.evenOdd][hyp*9+right*3+left][direction] != nullptr);
#endif
	return methodArray[i_cTriangleFactory.evenOdd][hyp*9+right*3+left][direction];
}
