
/*
 * Copyright (C) 2011 Technische Universitaet Muenchen
 * This file is part of the Sierpinski project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpinski
 *
 * This file was automatically generated by the sierpinski code generator
 */


inline void K_e_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data);
}

inline void K_o_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data);
}

static const int number_of_recursion_functions = 2;
typedef void (TThisClass::*TRecursiveMethod)(TVertexScalar, TVertexScalar, TVertexScalar, TVertexScalar, TVertexScalar, TVertexScalar, int);
enum ESFCMethod{
	SFC_METHOD_DEFAULT = 0,
	SFC_METHOD_FORCE_FORWARD = (1 << 0),
	SFC_METHOD_FORCE_BACKWARD = (1 << 1),
	SFC_METHOD_NEW_TO_OLD_EDGE_TYPES = (1 << 2),
	SFC_METHOD_OLD_TO_NEW_EDGE_TYPES = (1 << 3),
	SFC_METHOD_LIMITER___ = (1 << 4)
};

template <int specialMode = 0>
TRecursiveMethod getSFCMethod(CTriangle_Factory &i_cTriangleFactory)
{
	static TRecursiveMethod methodArray [2] [2] =
	{
	{
		&TThisClass::K_e_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_forward ,
		nullptr 
	} 
	} 	;

	assert(i_cTriangleFactory.triangleType != CTriangle_Enums::TRIANGLE_TYPE_INVALID);
	assert(i_cTriangleFactory.evenOdd != CTriangle_Enums::EVEN_ODD_INVALID);

	CTriangle_Enums::EDirection direction;
	if (specialMode & SFC_METHOD_FORCE_FORWARD)
	{
		direction = CTriangle_Enums::DIRECTION_FORWARD;
	}
	else if (specialMode & SFC_METHOD_FORCE_BACKWARD)
	{
		direction = CTriangle_Enums::DIRECTION_BACKWARD;
	}
	else
	{
		direction = i_cTriangleFactory.traversalDirection;
	}

		assert(i_cTriangleFactory.traversalDirection != CTriangle_Enums::DIRECTION_INVALID);
	assert(i_cTriangleFactory.hypNormal != CTriangle_Enums::NORMAL_INVALID);
#if DEBUG
	assert(methodArray[i_cTriangleFactory.evenOdd][direction] != nullptr);
#endif
	return methodArray[i_cTriangleFactory.evenOdd][direction];
}
