
/*
 * Copyright (C) 2011 Technische Universitaet Muenchen
 * This file is part of the Sierpinski project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpinski
 *
 * This file was automatically generated by the sierpinski code generator
 */


inline void K_e_bbb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_bob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void H_o_bbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void V_e_bnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_nob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_bno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void H_e_onn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_non_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
}

inline void V_o_non_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_e_nno_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void H_o_onn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_nno_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
}

inline void V_e_nno_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_non_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_e_noo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_oon_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
}

inline void V_o_oon_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old old
	// last touch
	cKernelClass.op_node_last_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
}

inline void H_e_ono_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old old
	// last touch
	cKernelClass.op_node_last_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
}

inline void K_o_noo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_ono_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
}

inline void V_e_ono_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old old
	// last touch
	cKernelClass.op_node_last_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
}

inline void H_o_oon_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old old
	// last touch
	cKernelClass.op_node_last_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
}

inline void V_e_bno_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void H_o_obn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bno_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
}

inline void K_e_nbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_bon_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void V_o_bon_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void H_e_onb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
}

inline void V_o_bob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_bbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_e_bbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_bob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_o_bbb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_bbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void H_e_bnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void V_o_bbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void V_e_bbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_bob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_bob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_bbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_e_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_nnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void H_o_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_nnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void V_e_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_nnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_nnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void H_e_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_nnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void V_o_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_nnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_e_ooo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_ooo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old old
	// last touch
	cKernelClass.op_node_last_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
}

inline void V_o_ooo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_ooo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old old
	// last touch
	cKernelClass.op_node_last_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
}

inline void K_o_ooo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_ooo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old old
	// last touch
	cKernelClass.op_node_last_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
}

inline void V_e_ooo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_ooo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old old
	// last touch
	cKernelClass.op_node_last_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
}

inline void K_e_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_nbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void H_o_nbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void V_e_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_nbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void V_o_nob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_bno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_e_bno_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_o_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_nnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void H_e_nnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void V_o_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_nnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void V_e_nbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_bon_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_bon_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_e_boo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_oob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
}

inline void V_o_oob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_boo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old old
	// last touch
	cKernelClass.op_node_last_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
}

inline void K_o_boo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_obo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
}

inline void V_e_obo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_boo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old old
	// last touch
	cKernelClass.op_node_last_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
}

inline void K_e_nbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_nnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_bon_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_o_nbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void H_e_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_nbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void V_o_nbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_e_obo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_boo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old old
	// last touch
	cKernelClass.op_node_last_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
}

inline void V_o_boo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_obo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
}

inline void K_o_obo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bno_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_ooo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_right_edge_stack->pop_returnPtr());
}

inline void H_e_bno_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void V_o_obn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bno_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
}

inline void K_e_nnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void H_o_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_nnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void V_e_nnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_nnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_nnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_bno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_e_oob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_ooo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
}

inline void H_o_bon_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// new old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void V_e_onb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// old new
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
}

inline void K_o_oob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_boo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old old
	// last touch
	cKernelClass.op_node_last_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
}

inline void V_e_boo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_oob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old old
	// last touch
	cKernelClass.op_node_last_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	vertex_data_comm_buffer_output->push_PtrValue(vertex_data_comm_left_edge_stack->pop_returnPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
}

inline void K_e_bbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_nbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_bob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_o_bbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_bbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_obo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
}

inline void K_e_nbb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_bon_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// new b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_o_nbb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_bno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// new b
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_e_obb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_boo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
}

inline void K_o_obb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bno_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_boo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// old b
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->getTopElementPtr());
}

inline void K_e_bnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_o_bnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_nnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_bbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b new
	// first touch
	cKernelClass.op_node_first_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->fakePush_returnPtr());
	// b new
	// first touch
	cKernelClass.op_node_first_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// b b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_e_bob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_oob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	// b b
	// first touch
	cKernelClass.op_node_first_touch_left(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_right_edge_stack->fakePush_returnPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_top(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
	// b old
	// middle touch
	cKernelClass.op_node_middle_touch_right(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, vertex_data_comm_left_edge_stack->getTopElementPtr());
}
